part of discord_dart;

class Client {
  Map _defaultOptions = {
    "bot": true,
    "internal": {
      "ws": {"large_threshold": 100}
    }
  };

  Map _handlers = {
    "ready": [], 
    "message": []
  };

  var _socket;
  int _lastS = null;

  Map options;

    _handleMsg(msg) {
    print('Message received: $msg');
    var json = JsonCodec().decode(msg);

    if (json['s'] != null) {
      this._lastS = json['s'];
    }
  }

  Client(String token) {
    this.options = this._defaultOptions..addAll(options);
   
    WebSocket.connect('wss://gateway.discord.gg?v=6&encoding=json').then((socket) {
      this._socket = socket;
      this._socket.listen(this._handleMsg);
    });
  }
  main() {
    print(this._socket);
  }
}